
class DraggableBall {

  PVector bpos;
  int ballRadius;
  boolean overBall;
  boolean locked;
  float xOffset; 
  float yOffset; 
  color fillColor;
  color baseColor;
  color edgeColor;

  DraggableBall( int r, color c ) {
    ballRadius = r;
    overBall = false;
    locked = false;
    xOffset = 0.0; 
    yOffset = 0.0; 
    fillColor = c;
    baseColor = c;
    edgeColor = c;
    bpos = new PVector(0, 0, 0);
  }





  void draw() {

    PVector mouseV = new PVector(mouseX, mouseY);
    if ( mouseV.dist(bpos) < ballRadius ) {
      overBall = true;  
      if (!locked) { 
        edgeColor = color(255); 
        fillColor = baseColor;
      }
    } 
    else {
      edgeColor = baseColor;
      fillColor = baseColor;
      overBall = false;
    }

    ellipseMode(RADIUS);  
    fill(fillColor);
    stroke(edgeColor);
    ellipse(bpos.x, bpos.y, ballRadius, ballRadius);
  }

  boolean mousePressed() {
    if (overBall) { 
      locked = true; 
      fillColor = lerpColor(baseColor, color(255), 0.5);
    xOffset = mouseX-bpos.x; 
    yOffset = mouseY-bpos.y;
      return(true);
    } 
    else {
      locked = false;
      return(false);
    }
  }

  void mouseDragged() {
    if (locked) {
      bpos.x = mouseX-xOffset; 
      bpos.y = mouseY-yOffset;
    }
  }

  void mouseReleased() {
    locked = false;
  }
}
